# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from cashfree_pg.models.manage_subscription_payment_request_action_details import ManageSubscriptionPaymentRequestActionDetails

class ManageSubscriptionPaymentRequest(BaseModel):
    """
    Request body to manage a subscription payment.
    """
    subscription_id: StrictStr = Field(..., description="The unique ID which was used to create subscription.")
    payment_id: StrictStr = Field(..., description="The unique ID which was used to create payment.")
    action: StrictStr = Field(..., description="Action to be performed on the payment. Possible values - CANCEL, RETRY.")
    action_details: Optional[ManageSubscriptionPaymentRequestActionDetails] = None
    __properties = ["subscription_id", "payment_id", "action", "action_details"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ManageSubscriptionPaymentRequest:
        """Create an instance of ManageSubscriptionPaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> ManageSubscriptionPaymentRequest:
        """Create an instance of ManageSubscriptionPaymentRequest from a JSON string"""
        temp_dict = json.loads(json_str)
        if "subscription_id, payment_id, action, action_details" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of action_details
        if self.action_details:
            _dict['action_details'] = self.action_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ManageSubscriptionPaymentRequest:
        """Create an instance of ManageSubscriptionPaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ManageSubscriptionPaymentRequest.parse_obj(obj)

        _obj = ManageSubscriptionPaymentRequest.parse_obj({
            "subscription_id": obj.get("subscription_id"),
            "payment_id": obj.get("payment_id"),
            "action": obj.get("action"),
            "action_details": ManageSubscriptionPaymentRequestActionDetails.from_dict(obj.get("action_details")) if obj.get("action_details") is not None else None
        })
        return _obj


