# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class OnboardSoundboxVpaRequest(BaseModel):
    """
    Request body to onboard soundbox vpa
    """
    vpa: StrictStr = Field(..., description="Terminal Vpa ,that need to onboard on soundbox")
    cf_terminal_id: StrictStr = Field(..., description="cashfree terminal id.")
    device_serial_no: StrictStr = Field(..., description="Device Serial No of soundbox")
    merchant_name: Optional[StrictStr] = Field(None, description="Merchant Name that need to onboard on soundbox")
    language: Optional[StrictStr] = Field(None, description="language of soundbox,currently English, Hindi, Tamil")
    __properties = ["vpa", "cf_terminal_id", "device_serial_no", "merchant_name", "language"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OnboardSoundboxVpaRequest:
        """Create an instance of OnboardSoundboxVpaRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> OnboardSoundboxVpaRequest:
        """Create an instance of OnboardSoundboxVpaRequest from a JSON string"""
        temp_dict = json.loads(json_str)
        if "vpa, cf_terminal_id, device_serial_no, merchant_name, language" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OnboardSoundboxVpaRequest:
        """Create an instance of OnboardSoundboxVpaRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OnboardSoundboxVpaRequest.parse_obj(obj)

        _obj = OnboardSoundboxVpaRequest.parse_obj({
            "vpa": obj.get("vpa"),
            "cf_terminal_id": obj.get("cf_terminal_id"),
            "device_serial_no": obj.get("device_serial_no"),
            "merchant_name": obj.get("merchant_name"),
            "language": obj.get("language")
        })
        return _obj


