# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, conlist
from cashfree_pg.models.split_order_recon_success_response_settlement import SplitOrderReconSuccessResponseSettlement
from cashfree_pg.models.split_order_recon_success_response_vendors_inner import SplitOrderReconSuccessResponseVendorsInner

class SplitOrderReconSuccessResponse(BaseModel):
    """
    Split Order Reconciliation Request Body
    """
    settlement: Optional[SplitOrderReconSuccessResponseSettlement] = None
    refunds: Optional[conlist(Dict[str, Any])] = Field(None, description="List of refunds associated with the order, if any.")
    vendors: Optional[conlist(SplitOrderReconSuccessResponseVendorsInner)] = Field(None, description="List of vendor settlements associated with the split settlement.")
    __properties = ["settlement", "refunds", "vendors"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SplitOrderReconSuccessResponse:
        """Create an instance of SplitOrderReconSuccessResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> SplitOrderReconSuccessResponse:
        """Create an instance of SplitOrderReconSuccessResponse from a JSON string"""
        temp_dict = json.loads(json_str)
        if "settlement, refunds, vendors" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of settlement
        if self.settlement:
            _dict['settlement'] = self.settlement.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in vendors (list)
        _items = []
        if self.vendors:
            for _item in self.vendors:
                if _item:
                    _items.append(_item.to_dict())
            _dict['vendors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SplitOrderReconSuccessResponse:
        """Create an instance of SplitOrderReconSuccessResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SplitOrderReconSuccessResponse.parse_obj(obj)

        _obj = SplitOrderReconSuccessResponse.parse_obj({
            "settlement": SplitOrderReconSuccessResponseSettlement.from_dict(obj.get("settlement")) if obj.get("settlement") is not None else None,
            "refunds": obj.get("refunds"),
            "vendors": [SplitOrderReconSuccessResponseVendorsInner.from_dict(_item) for _item in obj.get("vendors")] if obj.get("vendors") is not None else None
        })
        return _obj


