# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class SplitOrderReconSuccessResponseVendorsInner(BaseModel):
    """
    SplitOrderReconSuccessResponseVendorsInner
    """
    vendor_id: Optional[StrictStr] = Field(None, description="Unique identifier for the vendor.")
    settlement_id: Optional[StrictInt] = Field(None, description="Settlement ID associated with the vendor.")
    settlement_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Settlement amount allocated to the vendor.")
    settlement_eligibility_date: Optional[datetime] = Field(None, description="Date and time when the vendor is eligible for the settlement.")
    __properties = ["vendor_id", "settlement_id", "settlement_amount", "settlement_eligibility_date"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SplitOrderReconSuccessResponseVendorsInner:
        """Create an instance of SplitOrderReconSuccessResponseVendorsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> SplitOrderReconSuccessResponseVendorsInner:
        """Create an instance of SplitOrderReconSuccessResponseVendorsInner from a JSON string"""
        temp_dict = json.loads(json_str)
        if "vendor_id, settlement_id, settlement_amount, settlement_eligibility_date" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SplitOrderReconSuccessResponseVendorsInner:
        """Create an instance of SplitOrderReconSuccessResponseVendorsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SplitOrderReconSuccessResponseVendorsInner.parse_obj(obj)

        _obj = SplitOrderReconSuccessResponseVendorsInner.parse_obj({
            "vendor_id": obj.get("vendor_id"),
            "settlement_id": obj.get("settlement_id"),
            "settlement_amount": obj.get("settlement_amount"),
            "settlement_eligibility_date": obj.get("settlement_eligibility_date")
        })
        return _obj


