# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from cashfree_pg.models.eligibility_method_item import EligibilityMethodItem

class SubscriptionEligibilityResponse(BaseModel):
    """
    Subscrition eligibility API response
    """
    type: Optional[conlist(EligibilityMethodItem)] = Field(None, description="List of eligibile payment methods for the subscription.")
    __properties = ["type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionEligibilityResponse:
        """Create an instance of SubscriptionEligibilityResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> SubscriptionEligibilityResponse:
        """Create an instance of SubscriptionEligibilityResponse from a JSON string"""
        temp_dict = json.loads(json_str)
        if "type" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in type (list)
        _items = []
        if self.type:
            for _item in self.type:
                if _item:
                    _items.append(_item.to_dict())
            _dict['type'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionEligibilityResponse:
        """Create an instance of SubscriptionEligibilityResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionEligibilityResponse.parse_obj(obj)

        _obj = SubscriptionEligibilityResponse.parse_obj({
            "type": [EligibilityMethodItem.from_dict(_item) for _item in obj.get("type")] if obj.get("type") is not None else None
        })
        return _obj


